/**************************************************
 *  xExECZT@BME280@Cu
 *@@I2CŒʐM
 **************************************************/
#include "bme_lib2.h"
#include "i2c_lib2.h"
/*************************************************
 *  BME֐ [hݒ
 * 0xF2  ctrl_hum_reg   0000 0001  Oversample=1    
 * 0xF4  ctrl_meas_reg  0010 0111  Mode=11(Normal)
 * 0xF5  config_reg     1010 0000  stndby=1sec IIR-0 I2C * 
 ************************************************/
void bme_init(void){
    /** Reset **/
    CmdI2C(0x76,0xE0, 0xB6);            // reset
    /** Setting **/
    CmdI2C(0x76, 0xF2, 0x01);           // Ctrl_hum_reg
    CmdI2C(0x76, 0xF4, 0x27);           // Ctrl_meas_reg
    CmdI2C(0x76, 0xF5, 0xA0);           // config/reg
}
/**************************************
 *  f[^o
 **************************************/
void bme_getdata(void){
    unsigned char buf[8];
    
    SendI2C(0x76, 0xF7);
    GetDataI2C(0x76, buf, 8);      // Get from 0xF7 to 0xFE
    /** e32rbgf[^ɕϊ **/
    pres_raw = (uint32)(((uint32)buf[0] << 12) + ((uint32)buf[1] << 4) + ((uint32)buf[2] >> 4));
    temp_raw = (uint32)(((uint32)buf[3] << 12) + ((uint32)buf[4] << 4) + ((uint32)buf[5] >> 4));
    hum_raw  = (uint32)(((uint32)buf[6] << 8) + (uint32)buf[7]);
}
/************************************************
 * rpf[^擾 ꎞobt@@RcvBuf
 ************************************************/
void bme_gettrim(void){
    unsigned char buf[40];
    
    /*** rf[^o ***/
    SendI2C(0x76, 0x88);                // Send start Reg address
    GetDataI2C(0x76, buf, 24);          // Get from 0x88 to 0x9F
    SendI2C(0x76, 0xA1);                // Send start Reg address
    GetDataI2C(0x76, buf+24, 1);        // Get 0xA1
    SendI2C(0x76, 0xE1);                // Send start Reg address
    GetDataI2C(0x76, buf+25, 7);        // Get from 0xE1 to E7
    /** 16rbgf[^ɕϊ **/
    T1 = (unsigned int)((buf[1] << 8) | buf[0]);
    T2 = (int)((buf[3] << 8) | buf[2]);
    T3 = (int)((buf[5] << 8) | buf[4]);
    P1 = (unsigned int)((buf[7] << 8) | buf[6]);
    P2 = (int)((buf[9] << 8) | buf[8]);
    P3 = (int)((buf[11] << 8) | buf[10]);
    P4 = (int)((buf[13] << 8) | buf[12]);
    P5 = (int)((buf[15] << 8) | buf[14]);
    P6 = (int)((buf[17] << 8) | buf[16]);
    P7 = (int)((buf[19] << 8) | buf[18]);
    P8 = (int)((buf[21] << 8) | buf[20]);
    P9 = (int)((buf[23] << 8) | buf[22]);
    H1 = (unsigned int)buf[24];
    H2 = (int)((buf[26] << 8) | buf[25]);
    H3 = (unsigned int)buf[27];
    H4 = (int)((buf[28] << 4) | (0x0F & buf[29]));
    H5 = (int)((buf[30] << 4) | ((buf[29] >> 4) & 0x0F));
    H6 = (int)buf[31];
}
/**************************************
 * x̊r
 **************************************/
int32 calib_temp(int32 adc_T){
    int32 var1, var2, T;
    
    var1 = ((((adc_T >> 3) - ((int32)T1 << 1))) *((int32)T2)) >> 11;
    var2 = (((((adc_T >> 4) - ((int32)T1)) *((adc_T >> 4)-((int32)T1))) >> 12) *((int32)T3)) >> 14;
    t_fine = var1 + var2;
    T = (t_fine * 5 + 128) >> 8;
    return T;
}
/*********************************
 * C̊r
 *********************************/
uint32 calib_pres(int32 adc_P){
    int32 var1, var2;
    uint32 P;
    
    var1 = (t_fine >> 1) - (int32)64000;
    var2 = (((var1 >> 2) * (var1 >> 2)) >>11) * (int32)P6;
    var2 = var2 + ((var1 * (int32)P5) << 1);
    var2 = (var2 >> 2) + ((int32)P4 << 16);
    var1 = ((((int32)P3 * (((var1 >> 2)*(var1 >> 2)) >> 13)) >> 3) + (((int32)P2 * var1)>>1)) >> 18;
    var1 = (((int32)32768 + var1) * (int32)P1) >> 15;
    if(var1 == 0)
        return 0;
    P = ((uint32)(((int32)1048576 - adc_P) - (var2 >> 12))) * 3125;
    if(P < 0x80000000)
        P = (P << 1) / (uint32)var1;
    else
        P = (P / (uint32)var1) * 2;
    var1 = (P9 * ((int32)(((P >> 3) * (P >> 3)) >> 13))) >> 12;
    var2 = (((int32)(P >> 2)) * (int32)P8) >> 13;
    P = (uint32)((int32)P + ((var1 + var2 + (int32)P7) >> 4));
    return P;    
}
/**************************
 * x̊r
 ***************************/
uint32 calib_hum(int32 adc_H){
    int32 v_x1;
    
    v_x1 = (t_fine - ((int32)76800));
    v_x1 = (((((adc_H << 14) - (((int32)H4) << 20) - (((int32)H5) * v_x1))+
            ((int32)16384)) >> 15) * (((((((v_x1 * ((int32)H6)) >> 10) *
            (((v_x1 * ((int32)H3)) >>11) + ((int32)32768))) >> 10) + 
            ((int32)2097152)) * ((int32)H2) + 8192) >> 14));
    v_x1 = (v_x1 - (((((v_x1 >> 15) * (v_x1 >> 15)) >> 7) * ((int32)H1)) >> 4));
    if(v_x1 < 0)
        v_x1 = 0;
    if(v_x1 > 419430400)
        v_x1 = 419430400;
    return (uint32)(v_x1 >> 12);
}
    
    